@import "reset.scss";
@import "fonts.scss";

// Variables
:root {
  --header-bg-color: #22254e;
  --header-border-color: #888;
  --header-height: 4rem;
  --header-color: #333;
  --logo-first-color: #6a6aef;
  --logo-second-color: #e6e6e6;
  --nav-bg-color: #c0daf6;
  --nav-hover-bg-color: #e8f3fe;
  --nav-border-color: #8f8dcd;
  --nav-height: 1.5rem;
  --title-color: #db57b4;
  --title-border-color: #f6c5e3;
  --item-icon-color: #dc41cb;
  --item-bg-color: #fff;
  --item-color: #333;
  --item-accent-color: #dc41cb;
  --item-border-color: #e6bfe5;
  --item-hover-icon-color: #eee;
  --item-hover-bg-color: #744268;
  --item-hover-color: #eee;
  --item-hover-accent-color: #eee;
  --item-hover-border-color: #333;
  --footer-bg-color: #eee;
  --footer-border-color: #888;
  --footer-height: 1.5rem;
  --footer-color: #333;
}

// Use the entire page
html {
  margin: 0;
  padding: 0;
  font-size: 16px;

  > body {
    margin: 0;
    padding: 0;
  }
}

// Site header (on all pages)
header {
  background: var(--header-bg-color);
  height: var(--header-height);
  box-sizing: border-box;
  color: var(--header-color);
  padding: 0.5rem;
  padding-left: 4.5rem;

  img {
    width: 4rem;
    height: 4rem;
    padding: 0;
    margin: 0;
    font: 800 3rem/3rem "Lato";
    display: inline-block;
    position: absolute;
    top: 0;
    left: 0;
  }

  a {
    text-decoration: none;
  }

  span {
    font: 800 3rem/3rem "Lato";
    color: var(--logo-first-color);

    & + span {
      font: 400 3rem/3rem "Lato";
      color: var(--logo-second-color);
    }
  }
}

nav {
  background: var(--nav-bg-color);
  height: var(--nav-height);
  border-top: 0.0625rem solid var(--header-border-color);
  border-bottom: 0.0625rem solid var(--nav-border-color);
  box-sizing: border-box;

  ul {
    padding-left: 0.25rem;
    height: 100%;

    li {
      display: inline-block;
      height: 100%;
      position: relative;

      &.active,
      &:hover {
        background: var(--nav-hover-bg-color);
      }

      a {
        display: inline-block;
        height: 100%;
        text-decoration: none;
        padding-left: 0.5rem;
        padding-right: 0.5rem;

        span {
          line-height: 1rem;
          vertical-align: bottom;
          font: 400 0.75rem/1.5rem "Open Sans", sans-serif;
        }
      }

      &.output,
      &.model {
        padding-left: 0.25rem;

        &::before {
          content: '';
          position: absolute;
          left: 0;
          top: 0.375rem;
          border-left: 0.375rem solid black;
          border-top: 0.3125rem solid transparent;
          border-bottom: 0.3125rem solid transparent;
        }
      }
    }
  }
}

// Site content
article {
  min-height: calc(100vh - var(--nav-height) - var(--header-height) - var(--footer-height));
  box-sizing: border-box;
  padding: 1rem;
  position: relative;

  *:first-child {
    padding-top: 0;
    margin-top: 0;
  }

  h1 {
    color: var(--title-color);
    font: 800 2rem "Lato", "Open Sans", sans-serif;
    margin-bottom: 1rem;
    border-bottom: 0.1875rem double var(--title-border-color)
  }

  h2 {
    color: var(--title-color);
    font: 400 1.5rem "Lato", "Open Sans", sans-serif;
    margin-top: 1rem;
    margin-bottom: 1rem;
    border-bottom: 0.1875rem double var(--title-border-color);
    display: inline-block;
  }

  h3 {
    color: var(--title-color);
    font: 400 1.25rem "Lato", "Open Sans", sans-serif;
    margin-top: 1rem;
    margin-bottom: 1rem;
  }

  code {
    font: 400 1rem "inconsolata", monospace;
    color: var(--title-color);
  }

  pre {
    font: 400 1rem "inconsolata", monospace;
    background: #333;
    color: #eee;
    padding: 0.5rem;
    margin-left: 0.5rem;
    margin-top: 1rem;
    margin-bottom: 1rem;

    code {
      color: #eee;
    }
  }

  .markdown {
    ul {
      list-style: disc;
      list-style-position: inside;

      li {
        font: 400 1rem "Open Sans", sans-serif;

        &::marker {
          color: var(--title-color);
        }

        &:not(:last-child) {
          margin-bottom: 0.5rem;
        }
      }
    }

    blockquote {
      border-left: 0.25rem solid #ddd;
      margin-left: 0.5rem;
      margin-top: 1rem;
      margin-bottom: 1rem;
      padding-top: 0.25rem;
      padding-bottom: 0.25rem;

      p {
        padding-left: 0.5rem;
        font: 400 1rem "Open Sans", sans-serif;
        font-style: italic;
      }
    }
  }

  p {
    font: 400 1rem "Open Sans", sans-serif;

    & + p {
      margin-top: 0.75rem;
    }
  }

  em {
    font-style: italic;
  }

  strong {
    font-weight: bold;
  }

  ul.models {
    list-style: none;
    display: table;
    max-width: 100%;
    position: relative;
    margin: 0 auto;

    li.model {
      position: relative;
      max-width: 100%;
      display: table-row;

      a {
        position: absolute;
        display: block;
        box-sizing: border-box;
        width: 100%;
        height: 4rem;
        padding: 0.5rem;
        border: 1px solid var(--item-border-color);
        border-radius: 0.5rem;
        box-sizing: border-box;
        top: 0.55rem;
        left: 0;

        background: var(--item-bg-color);

        &:hover {
          background: var(--item-hover-bg-color);
          border: 1px solid var(--item-hover-border-color);

          & ~ .icon svg {
            fill: var(--item-hover-icon-color);
          }

          & ~ .info {
            span.type {
              color: var(--item-hover-accent-color);
            }

            span.name {
              color: var(--item-hover-color);
            }

            span.author {
              span.name {
                color: var(--item-hover-color);
              }
            }
          }

          & ~ .description {
            span.summary {
              color: var(--item-hover-color);
              border-color: var(--item-hover-accent-color);
            }
          }
        }
      }

      .icon {
        pointer-events: none;
        display: table-cell;
        padding: 0.75rem 0.5rem;
        width: 4rem;
        height: 4rem;
        box-sizing: border-box;
        position: relative;

        svg {
          position: absolute;
          top: 0.125rem;
          left: 0;
          display: inline-block;
          width: 100%;
          height: 100%;
          fill: var(--item-icon-color);
        }
      }

      .info {
        pointer-events: none;
        display: table-cell;
        padding: 0.75rem 0.5rem;
        padding-left: 0;
        height: 4.5rem;
        box-sizing: border-box;
        position: relative;

        span.type {
          font: 800 0.75rem/1rem "Lato", sans-serif;
          color: var(--item-accent-color);
          display: block;
          white-space: nowrap;
        }

        span.name {
          font: 400 1rem "Lato", sans-serif;
          color: var(--item-color);
          display: block;
          white-space: nowrap;
        }

        span.author {
          display: block;
          white-space: nowrap;

          img.avatar {
            display: inline-block;
            width: 1rem;
            height: 1rem;
            border-radius: 0.25rem;
            vertical-align: middle;
            line-height: 1rem;
            margin-right: 0.25rem;
          }

          span.name {
            display: inline;
            color: var(--item-color);
            font: 0.75rem/1rem "Lato", sans-serif;
            vertical-align: middle;
          }
        }
      }

      .description {
        pointer-events: none;
        display: table-cell;
        padding: 0.75rem 0.5rem;
        height: 2.75rem;
        max-height: 2.75rem;
        position: relative;

        .summary {
          font: 400 0.75rem "Lato", sans-serif;
          color: var(--item-color);
          display: block;
          border-left: 0.1875rem double var(--item-accent-color);
          height: 2.75rem;
          max-height: 2.75rem;
          vertical-align: middle;
          top: 0.25rem;
          position: relative;
          padding-left: 0.5rem;
          overflow: hidden;
        }
      }
    }
  }

  // The model description on a model page
  .model {
    border: 0.0625rem solid #ddd;
    border-radius: 0.25rem;
    margin-bottom: 1rem;
    padding-top: 0.5rem;

    .info {
      display: table;
      margin: 0 auto;

      .model-metadata {
        display: table-row;

        > * {
          display: table-cell;
          line-height: 1.5rem;

          > * {
            vertical-align: middle;
          }

          > .icon {
            display: inline-block;
            margin-right: 0.5rem;
            width: 1rem;
            height: 1rem;
          }

          &:first-child {
            padding-right: 0.5rem;
            text-align: right;

            &::after {
              content: ':';
            }
          }
        }

        > .author {
          img.avatar {
            width: 1rem;
            height: 1rem;
            margin-right: 0.5rem;
          }
        }
      }
    }

    .description {
      border-top: 0.1875rem double #ddd;
      margin: 1rem auto;
      padding-top: 1rem;
      text-align: center;

      p.actions {
        padding-top: 1rem;
        border-top: 0.0625rem solid #ddd;
        margin-top: 1rem;
      }
    }
  }

  table.outputs {
    display: block;
    margin-top: 0.5rem;
    max-width: 100%;
    min-width: 100%;
    width: 100%;
    margin: 0 auto;
    box-sizing: border-box;
    border-collapse: separate;
    border-spacing: 0;

    // TableFilter overrides
    caption {
      .tot,
      .status {
        font: 400 0.75rem/1.5rem "Open Sans", sans-serif;
      }
    }

    // TableFilter sticky override to include the filter fields
    &.TF.sticky {
      th {
        top: 42px;
      }

      tr.fltrow {
        position: sticky;
        top: 0px;
      }
    }

    tr.list-header {
      th {
        border-bottom: 0.1875rem double #333;
      }

      th > p {
        font-weight: bold;
        text-align: center;
        display: block;
        text-overflow: ellipsis;
        box-sizing: border-box;
        overflow: hidden;
      }

      th > * {
        padding-bottom: 0.25rem !important;
        vertical-align: bottom;

        &:last-child {
          padding-right: 0.5rem;
        }
      }

      th > span.icon {
        fill: #888;
        display: block;
      }
    }

    tr.list-header, tr.output, tr.fltrow {
      > td {
        font: 400 0.875rem/1rem "Lato";

        input {
          font: 400 0.875rem/1rem "Lato";
          text-align: center;
        }

        &:first-child {
          width: 1%;
        }
      }

      &.output {
        > td {
          border-left: 0.0625rem solid #ddd;
          border-right: 0.0625rem solid #ddd;
        }

        &:last-child {
          td:first-child {
            border-bottom-left-radius: 0.25rem;
          }

          td:last-child {
            border-bottom-right-radius: 0.25rem;
          }
        }
      }

      * > span.icon {
        svg {
          padding-left: 0.5rem;
          width: 2rem;
          height: 2rem;
          vertical-align: middle;
          fill: var(--item-icon-color);
        }
      }

      .configuration-column,
      .actions {
        text-align: center;

        a {
          &:not(:first-child) {
            margin-left: 0.25rem;
          }
        }
      }

      * > p {
        padding-bottom: 0.5rem;
      }

      td > p {
        vertical-align: middle;
      }

      // Ensure the "New Output" text appears on one line
      &.new-run > td {
        // For archaic reasons, ensures the 'width' on table is respected.
        &:nth-child(2) {
          width: 1%;
        }

        p {
          white-space: nowrap;
        }
      }
    }
  }

  iframe {
    position: absolute;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    width: 100%;
    height: 100%;
  }
}

// Site footer (on all pages):
footer {
  background: var(--footer-bg-color);
  border-top: 0.0625rem solid var(--footer-border-color);
  height: var(--footer-height);
  color: var(--footer-color);
  line-height: var(--footer-height);
  box-sizing: border-box;
  white-space: nowrap;
  vertical-align: middle;
  font: 400 0.75rem/1rem "Lato";

  .left {
    margin-top: 0.125rem;
    margin-left: 0.5rem;
    height: 1rem;
    vertical-align: middle;
    line-height: 1rem;
    float: left;

    span:not(:last-child) {
      margin-right: 0.5rem;
    }
  }

  .right {
    margin-top: 0.125rem;
    height: 1rem;
    vertical-align: middle;
    line-height: 1rem;
    float: right;
    white-space: nowrap;

    img {
      height: 1rem;
      vertical-align: middle;
      line-height: 1rem;
      margin-left: 0.25rem;
      margin-right: 0.5rem;
    }
  }
}
